unit Setting;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, PrintTxt;

type
  TSettingForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    CheckBox2: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label4: TLabel;
    Button3: TButton;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Label5: TLabel;
    Edit4: TEdit;
    UpDown4: TUpDown;
    Label6: TLabel;
    Edit5: TEdit;
    UpDown5: TUpDown;
    Label7: TLabel;
    Edit6: TEdit;
    UpDown6: TUpDown;
    Edit7: TEdit;
    UpDown7: TUpDown;
    Edit8: TEdit;
    UpDown8: TUpDown;
    Edit9: TEdit;
    UpDown9: TUpDown;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Edit10: TEdit;
    UpDown10: TUpDown;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Button4: TButton;
    CheckBox6: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    PaperInfo: TPaperInfo;
    Fnc: Boolean;
    Tsc: Boolean;
    Pmc: Boolean;
  end;

var
  SettingForm: TSettingForm;

implementation

uses Frame;

{$R *.DFM}

procedure TSettingForm.FormShow(Sender: TObject);
var
  PrintOption: Integer;
begin
  PaperInfo := CollectPaperInfo; // ߂B

  Fnc := False; // tHgύXꂽ̃tO
  Tsc := False; // ^uTCY^uTCY̎ݒ肪ύXꂽ̃tO
  Pmc := False; // [hύXꂽ̃tO

  ClientWidth := 372;

  ClientHeight := 314;

  UpDown1.Position := FrameForm.TabSize;

  CheckBox1.Checked := FrameForm.DefaultExt; CheckBox1Click(Sender);

  Updown10.Position := FrameForm.BCount;

  UpDown2.Position := FrameForm.BSize div 1024; // 1K oCgPʂ̒lB

  CheckBox2.Checked := FrameForm.RichEdit1.WordWrap;

  PrintOption := FrameForm.Parameter1['PrintOption'];

  CheckBox3.Checked := ((PrintOption and poPageNumber) <> 0);

  CheckBox4.Checked := ((PrintOption and poFileName) <> 0);

  CheckBox5.Checked := ((PrintOption and poTimeStamp) <> 0);

  CheckBox6.Checked := FrameForm.Indent;

  CheckBox7.Checked := FrameForm.Parameter1.VBools['BinaryOperation'];

  CheckBox8.Checked := FrameForm.Parameter1.VBools['FindOption'];

  UpDown3.Position := FrameForm.Parameter1['LineNumber'];

  UpDown4.Position := FrameForm.Parameter1['Partition'];

  UpDown5.Position := FrameForm.Parameter1['PartitionGap'];

  UpDown6.Position := FrameForm.Parameter1['PITopMargin'];

  UpDown7.Position := FrameForm.Parameter1['PIBottomMargin'];

  UpDown8.Position := FrameForm.Parameter1['PILeftMargin'];

  UpDown9.Position := FrameForm.Parameter1['PIRightMargin'];
end;

procedure TSettingForm.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
  begin
    UpDown1.Enabled := False;
    Edit1.Enabled := False;
  end
  else
  begin
    UpDown1.Enabled := True;
    Edit1.Enabled := True;
  end;
end;

procedure TSettingForm.Button1Click(Sender: TObject);
var
  mf: Boolean;
  i, j, bl, bs, bi, ts: Integer;
  PrintOption: Integer;
  ss, gss, vs, gvs: Integer;
  ext: String;
begin
  { f[^XVB}
  FrameForm.ModifiedCheck;
  FrameForm.BinaryCheck;
  mf := FrameForm.RichEdit1.Modified;
  ss := FrameForm.RichEdit1.SelStart;
  gss := FrameForm.Local2GlobalSel(ss); // O[oȃZʒu
  vs := FrameForm.ViewTopSel;
  gvs := FrameForm.Local2GlobalSel(vs); // O[oȃZʒu
  bl := FrameForm.BlockLen; // 1ubN̒
  bs := FrameForm.BSize div 1024; // 1K Byte Pʂ̃ubNTCY

  if Fnc = True then
  begin
    FrameForm.RichEdit1.Font := FrameForm.FontDialog1.Font;
    FrameForm.Parameter1.VStrings['FontName'] := FrameForm.FontDialog1.Font.Name;
    FrameForm.Parameter1['FontSize'] := FrameForm.FontDialog1.Font.Size;
    FrameForm.Parameter1.VFontStyles['FontStyle'] := FrameForm.FontDialog1.Font.Style;
    FrameForm.Parameter1['FontColor'] := FrameForm.FontDialog1.Font.Color;
    FrameForm.RichEdit1.Modified := mf;
  end;

  if (FrameForm.TabSize <> UpDown1.Position) or (FrameForm.DefaultExt <> CheckBox1.Checked) then
  begin
    ts := UpDown1.Position;
    if CheckBox1.Checked then
    begin
      ext := LowerCase(ExtractFileExt(FrameForm.InfoList1.TagStr));
      if Length(ext) = 0 then ext := '.txt';

      if ext = '.pas' then
        ts := 2
      else if (ext = '.c') or (ext = '.h') or (ext = '.cpp') or (ext = '.hpp') then
        ts := 4
      else
        ts := 8;
    end;
    FrameForm.SetTabSize(ts); // ^uTCYݒ肷B
    FrameForm.TabSize := ts;
    FrameForm.Parameter1['TabSize'] := ts;
    FrameForm.DefaultExt := CheckBox1.Checked;
    FrameForm.Parameter1.VBools['DefaultExt'] := CheckBox1.Checked;
    FrameForm.RichEdit1.Modified := mf;
  end;

  if FrameForm.RichEdit1.WordWrap <> CheckBox2.Checked then
  begin
    FrameForm.RichEdit1.WordWrap := CheckBox2.Checked;
    FrameForm.Parameter1.VBools['WordWrap'] := CheckBox2.Checked;
  end;

  if FrameForm.Indent <> CheckBox6.Checked then
  begin
    FrameForm.Indent := CheckBox6.Checked;
    FrameForm.Parameter1.VBools['Indent'] := CheckBox6.Checked;
  end;

  if FrameForm.InfoList1.BinaryOperation <> CheckBox7.Checked then
  begin
    FrameForm.InfoList1.BinaryOperation := CheckBox7.Checked;
    FrameForm.Parameter1.VBools['BinaryOperation'] := CheckBox7.Checked;
  end;

  if FrameForm.FindOption <> CheckBox8.Checked then
  begin
    FrameForm.FindOption := CheckBox8.Checked;
    FrameForm.Parameter1.VBools['FindOption'] := CheckBox8.Checked;
  end;

  if FrameForm.BCount <> UpDown10.Position then
  begin
    FrameForm.BCount := UpDown10.Position;
    FrameForm.Parameter1['BCount'] := UpDown10.Position;
    Pmc := True;
  end;

  if FrameForm.BSize <> UpDown2.Position * 1024 then
  begin
    FrameForm.BSize := UpDown2.Position * 1024;
    FrameForm.Parameter1['BSize'] := UpDown2.Position; // 1K oCgPʂ̒lB
    Pmc := True;
  end;

  PrintOption := 0;
  if CheckBox3.Checked then
    PrintOption := PrintOption or poPageNumber;
  if CheckBox4.Checked then
    PrintOption := PrintOption or poFileName;
  if CheckBox5.Checked then
    PrintOption := PrintOption or poTimeStamp;
  FrameForm.Parameter1['PrintOption'] := PrintOption;

  FrameForm.Parameter1['LineNumber'] := UpDown3.Position;

  FrameForm.Parameter1['Partition'] := UpDown4.Position;

  FrameForm.Parameter1['PartitionGap'] := UpDown5.Position;

  if UpDown6.Position < PaperInfo.PITopMargin then
    FrameForm.Parameter1['PITopMargin'] := PaperInfo.PITopMargin
  else
    FrameForm.Parameter1['PITopMargin'] := UpDown6.Position;

  if UpDown7.Position < PaperInfo.PIBottomMargin then
    FrameForm.Parameter1['PIBottomMargin'] := PaperInfo.PIBottomMargin
  else
    FrameForm.Parameter1['PIBottomMargin'] := UpDown7.Position;

  if UpDown8.Position < PaperInfo.PILeftMargin then
    FrameForm.Parameter1['PILeftMargin'] := PaperInfo.PILeftMargin
  else
    FrameForm.Parameter1['PILeftMargin'] := UpDown8.Position;

  if UpDown9.Position < PaperInfo.PIRightMargin then
    FrameForm.Parameter1['PIRightMargin'] := PaperInfo.PIRightMargin
  else
    FrameForm.Parameter1['PIRightMargin'] := UpDown9.Position;

  FrameForm.Parameter1.VStrings['FindStr'] := FrameForm.FindStr;

  if Pmc = True then
  begin
    bl := bl * UpDown2.Position div bs; // V1ubN̒
    if bl = 0 then bi := 0
    else bi := gvs div bl; // VubNԍ̗\l
    FrameForm.RemakeData(bi);
    ss := FrameForm.Global2LocalSel(gss); // [JȃZʒu
    i := FrameForm.GlobalSel2Block(gss); // ubNԍ
    vs := FrameForm.Global2LocalSel(gvs); // [JȃZʒu
    j := FrameForm.GlobalSel2Block(gvs); // ubNԍ

    if bi <> j then
    begin
      FrameForm.BIndex := j;
      case FrameForm.EditMode of
        0: FrameForm.RichEdit1.Text := FrameForm.InfoList1.TextItems[j]; // Text Mode
        1: FrameForm.RichEdit1.Text := FrameForm.InfoList1.CrystalItems[j]; // Crystal Mode
        2: FrameForm.RichEdit1.Text := FrameForm.InfoList1.DumpItems[j]; // Dump Mode
        3: FrameForm.RichEdit1.Text := FrameForm.InfoList1.BinaryItems[j]; // Binary Mode
      end;
    end;

    FrameForm.RichEdit1.Modified := mf;
    FrameForm.SetViewTopSel(vs);
    if i = j then
      FrameForm.RichEdit1.SelStart := ss;
    FrameForm.DispStatus;
  end
  else
  begin
    FrameForm.RemakeData(FrameForm.BIndex);
    FrameForm.SetViewTopSel(vs);
    FrameForm.RichEdit1.SelStart := ss;
    FrameForm.DispStatus;
  end;

  FrameForm.Parameter1.SaveToFile; // sȂݒLɂB
end;

procedure TSettingForm.Button3Click(Sender: TObject);
begin
  FrameForm.FontDialog1.Font := FrameForm.RichEdit1.Font;
  if FrameForm.FontDialog1.Execute then
    Fnc := True;
end;

procedure TSettingForm.Button4Click(Sender: TObject);
begin
  FrameForm.FontDialog1.Font.Name := 'lr SVbN';
  FrameForm.FontDialog1.Font.Size := 12;
  FrameForm.FontDialog1.Font.Style := [];
  FrameForm.FontDialog1.Font.Color := TColor(-2147483640);

  UpDown1.Position := 4; Edit1.Text := '4';

  CheckBox1.Checked := True;

  Updown10.Position := 0; Edit10.Text := '0';

  UpDown2.Position := 16; Edit2.Text := '16'; // 1K oCgPʂ̒lB

  CheckBox2.Checked := True;

  CheckBox3.Checked := True;

  CheckBox4.Checked := True;

  CheckBox5.Checked := True;

  CheckBox6.Checked := True;

  CheckBox7.Checked := False;

  CheckBox8.Checked := True;

  UpDown3.Position := 0; Edit3.Text := '0';

  UpDown4.Position := 1; Edit4.Text := '1';

  UpDown5.Position := 32; Edit5.Text := '32';

  UpDown6.Position := 76; Edit6.Text := '76';

  UpDown7.Position := 92; Edit7.Text := '92';

  UpDown8.Position := 76; Edit8.Text := '76';

  UpDown9.Position := 76; Edit9.Text := '76';

  Fnc := True; // tHgύXꂽ̃tO
  Tsc := True; // ^uTCY^uTCY̎ݒ肪ύXꂽ̃tO
  Pmc := True; // [hύXꂽ̃tO
end;

end.
